#include < amxmodx >
#include < cstrike >
#include < fakemeta >
#include < hamsandwich >

#define VERSION 		"1.0"
#define HEALTH_BAR_MODEL	"sprites/health.spr"
#define is_player(%1)		( 1 <= %1 <= g_maxPlayers )

enum _: g_enum_playerStatus
{
	DISCONNECTED = 0,
	DEAD,
	ALIVE
}

new g_playerBar[ 33 ], g_playerStatus[ 33 ], CsTeams: g_playerTeam[ 33 ], g_playerBot[ 33 ], g_playerMaxHealth[ 33 ]
new pcvarBotSupport, pcvarShowMode, pcvarSpec, cvarSpec, cvarShowMode, cvarBotSupport
new g_maxPlayers, ENTITIES_USER, fwShowMode, botRegistered

public plugin_init( ) 
{
	register_plugin( "Health Bar", VERSION, "Bboy Grun" )
	
	register_cvar( "Health_Bars", VERSION, FCVAR_SERVER | FCVAR_SPONLY )
	set_cvar_string( "Health_Bars", VERSION )
	
	RegisterHam( Ham_Spawn, "player", "fwHamSpawn", 1 )
	
	register_event( "HLTV", "evRoundStart", "a", "1=0", "2=0" )
	register_event( "DeathMsg", "evDeathMsg", "a" )
	register_event( "Health", "evHealth", "be" )
	
	pcvarShowMode = 	register_cvar( "health_ShowMode", "2" )
	pcvarBotSupport = 	register_cvar( "health_BotSupport", "0" )
	pcvarSpec = 		register_cvar( "health_ShowToSpectators", "1" )
	
	g_maxPlayers = get_maxplayers( )
	
	createHealthHuds( )
	evRoundStart( )
}

public plugin_init_bots( id )
{
	RegisterHamFromEntity( Ham_Spawn, id, "fwHamSpawn", 1 )
	
	fwHamSpawn( id )
}

public plugin_precache( )
{
	precache_model( HEALTH_BAR_MODEL )
}

public client_putinserver( id )
{
	g_playerStatus[ id ] = DEAD
	g_playerTeam[ id ] = CS_TEAM_SPECTATOR
	g_playerBot[ id ] = is_user_bot( id )
	g_playerMaxHealth[ id ] = 0
	
	if( cvarBotSupport && !botRegistered && g_playerBot[ id ] && get_cvar_num( "bot_quota" ) > 0 )
	{
		set_task( 0.4, "plugin_init_bots", id )
		botRegistered = 1
	}
}

public client_disconnect( id )
{
	g_playerStatus[ id ] = DISCONNECTED
	g_playerTeam[ id ] = CS_TEAM_UNASSIGNED
	g_playerBot[ id ] = 0
	g_playerMaxHealth[ id ] = 0
	
	engfunc( EngFunc_SetOrigin, g_playerBar[ id ], Float: { -9999.0, -9999.0, -9999.0 } )
}

public fwAddToFullPack( es, e, ent, host, host_flags, player, p_set )
{
	if( !is_player( host ) || g_playerBot[ host ] || ( g_playerStatus[ host ] != ALIVE && !cvarSpec )
	|| !pev_valid( ent ) || pev( ent, pev_iuser1 ) != ENTITIES_USER || host == ent )
	{
		return FMRES_IGNORED;
	}
	
	new owner = pev( ent, pev_iuser2 )
	
	if( !is_player( owner ) || g_playerStatus[ owner ] != ALIVE || ( !cvarBotSupport && g_playerBot[ owner ] ) )
	{
		return FMRES_IGNORED;
	}
	
	if( cvarShowMode == 1 && g_playerStatus[ owner ] == ALIVE && g_playerStatus[ host ] == ALIVE
	&& g_playerTeam[ host ] != g_playerTeam[ owner ] )
	{
		return FMRES_IGNORED;
	}
	
	if( owner == host )
	{
		return FMRES_IGNORED;
	}
	
	new Float: playerOrigin[ 3 ]
	pev( owner, pev_origin, playerOrigin )
		
	playerOrigin[ 2 ] += 30.0
		
	engfunc( EngFunc_SetOrigin, ent, playerOrigin )

	return FMRES_IGNORED;
}

public fwHamSpawn( id )
{
	if( is_user_alive( id ) )
	{
		g_playerStatus[ id ] = ALIVE
		g_playerTeam[ id ] = cs_get_user_team( id )
		
		checkHealth( id )
	}
}

public evDeathMsg( )
{
	new id = read_data( 2 )
	
	g_playerStatus[ id ] = DEAD
	g_playerTeam[ id ] = cs_get_user_team( id )
	g_playerMaxHealth[ id ] = 0
	
	engfunc( EngFunc_SetOrigin, g_playerBar[ id ], Float: { -9999.0, -9999.0, -9999.0 } )
}

public evHealth( id )
{
	checkHealth( id )
}

public evRoundStart( )
{
	cvarShowMode = 		get_pcvar_num( pcvarShowMode )
	cvarSpec = 		get_pcvar_num( pcvarSpec )	
	
	for( new i = 1; i <= g_maxPlayers; i ++ )
	{
		engfunc( EngFunc_SetOrigin, g_playerBar[ i ], Float: { -9999.0, -9999.0, -9999.0 } )
	}
	
	new valueBotSupport = get_pcvar_num( pcvarBotSupport )
	
	if( cvarShowMode > 0 )
	{
		if( !fwShowMode )
		{
			fwShowMode = register_forward( FM_AddToFullPack, "fwAddToFullPack", 1 )
		}
	}
	else
	{
		if( fwShowMode )
		{
			unregister_forward( FM_AddToFullPack, fwShowMode, 1 )
			fwShowMode = 0
		}
	}
	
	if( valueBotSupport )
	{	
		if( !botRegistered )
		{
			for( new id = 1; id <= g_maxPlayers; id ++ )
			{
				if( g_playerBot[ id ] )
				{
					plugin_init_bots( id )
					botRegistered = 1
					break;
				}
			}
		}
	}
	
	cvarBotSupport = valueBotSupport
}

stock checkHealth( id )
{
	new hp = get_user_health( id )
	
	if( g_playerMaxHealth[ id ] < hp )
	{
		g_playerMaxHealth[ id ] = hp
		ent_setFrame( id, 0 )
	}
	else
	{
		ent_setFrame( id, 1, hp )
	}
}

stock ent_setFrame( id, check = 1, health = 0 )
{
	if( check )
	{
		health -= 1
		set_pev( g_playerBar[ id ], pev_frame, 0.0 + ( ( health * 100 ) / g_playerMaxHealth[ id ] ) )
	}
	else
	{
		set_pev( g_playerBar[ id ], pev_frame, 99.0 )
	}
}

createHealthHuds( )
{
	new allocString = engfunc( EngFunc_AllocString, "env_sprite" )
	
	for( new i = 1; i <= g_maxPlayers; i ++ )
	{
		g_playerBar[ i ] = engfunc( EngFunc_CreateNamedEntity, allocString )
		
		if( pev_valid( g_playerBar[ i ] ) )
		{
			set_pev( g_playerBar[ i ], pev_solid, SOLID_NOT )
			set_pev( g_playerBar[ i ], pev_movetype, MOVETYPE_FOLLOW )
			set_pev( g_playerBar[ i ], pev_iuser2, i )
			set_pev( g_playerBar[ i ], pev_iuser1, ENTITIES_USER )
			set_pev( g_playerBar[ i ], pev_scale, 0.1 )
			engfunc( EngFunc_SetModel, g_playerBar[ i ], HEALTH_BAR_MODEL )
			set_pev( g_playerBar[ i ], pev_renderfx, kRenderTransAlpha )
			set_pev( g_playerBar[ i ], pev_renderamt, 0.0 )
			
			dllfunc( DLLFunc_Spawn, g_playerBar[ i ] )
		}
	}
}